diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 15a4a1967..59cbacaac 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1442,7 +1442,7 @@ public class World implements WorldSource {
                     if(block != null)
                     {
                         int metadata = getBlockMetadata(dx, dy, dz);
-                        if (block.collidesWithEntity(entity) && entity.collidesWithBlock(block, metadata))
+                        if (block.collidesWithEntity(entity, this, dx, dy, dz) && entity.collidesWithBlock(block, metadata))
                         {
                             block.getCollidingBoundingBoxes(this, dx, dy, dz, axisalignedbb, collidingBoundingBoxes);
                         }
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
new file mode 100644
index 000000000..71b6c0d33
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
@@ -0,0 +1,37 @@
+// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
+// Jad home page: http://www.kpdus.com/jad.html
+// Decompiler options: packimports(3) braces deadcode
+
+package net.minecraft.core.world.biome;
+
+import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.generate.feature.tree.*;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Random;
+
+// Referenced classes of package net.minecraft.src:
+//            BiomeGenBase, SpawnListEntry, EntityWolf, WorldGenForest,
+//            WorldGenBigTree, WorldGenTrees, WorldGenerator
+
+public class BiomeCaatinga extends Biome
+{
+
+    public BiomeCaatinga(String key) {
+        super(key);
+    }
+
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(Random random)
+    {
+        if(random.nextInt(5) == 0)
+        {
+            return new WorldFeatureTreeShrub(Block.leavesCaatinga.id, Block.logOak.id);
+        } else
+        {
+            return new WorldFeatureTreeCaatinga(Block.leavesCaatinga.id, Block.logOak.id);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/biome/Biomes.java b/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 784278d6c..0f37427e6 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -6,6 +6,7 @@ import net.minecraft.core.world.weather.Weather;
 
 public class Biomes
 {
+
     public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("rainforest").setColor(0x1cf100).setBlockedWeathers(Weather.overworldSnow));
     public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("swampland").setColor(0x00ff78));
     public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("seasonal_forest").setColor(0x64ce15));
@@ -27,6 +28,7 @@ public class Biomes
     public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Block.dirtScorched.id).setTopBlock(Block.dirtScorched.id));
     public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("swampland.muddy").setColor(0x522700));
     public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.grassScorched.id).setFillerBlock(Block.dirtScorched.id));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xFFFFFF).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
 
     public static Biome register(String key, Biome biome)
     {
diff --git a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index 2e16404fb..f02eb65cd 100644
--- a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -364,7 +364,7 @@ public final class BiomeProviderOverworld
         );
 
         brm.addRange(Biomes.OVERWORLD_PLAINS,
-                new BiomeRange(0.95, 1.0, 0.0125, 0.4, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.90, 1.0, 0.0125, 0.5, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_DESERT,
                 new BiomeRange(0.95, 1.0, 0.0, 0.2, 0.0, 1.0, 0.0, 1.0)
@@ -384,7 +384,10 @@ public final class BiomeProviderOverworld
         );
         brm.addRange(Biomes.OVERWORLD_FOREST,
                 new BiomeRange(0.75, 0.95, 0.2, 0.85, 0.0, 1.0, 0.0, 1.0),
-                new BiomeRange(0.95, 1.0, 0.4, 0.85, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.95, 1.0, 0.5, 0.85, 0.0, 1.0, 0.0, 1.0)
+        );
+        brm.addRange(Biomes.OVERWORLD_CAATINGA,
+                new BiomeRange(0.98, 1.0, 0.2, 0.65, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_RAINFOREST,
                 new BiomeRange(0.95, 1.0, 0.85, 1.0, 0.0, 1.0, 0.0, 1.0)
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index dac157166..a8a8848b4 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -327,7 +327,7 @@ public class Chunk
         }
 
         section.setBlock(x, y % ChunkSection.SECTION_SIZE_Y, z, id);
-        section.setData(x, y % ChunkSection.SECTION_SIZE_Y, z, id);
+        section.setData(x, y % ChunkSection.SECTION_SIZE_Y, z, 0);
 
         int worldX = xPosition * CHUNK_SIZE_X + x;
         int worldZ = zPosition * CHUNK_SIZE_Z + z;
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index a14a0658a..7ea2c70fe 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -258,6 +258,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_PLAINS) {
             treeDensity -= 20;
         }
+        if (biome == Biomes.OVERWORLD_CAATINGA) {
+            treeDensity += k4 + 2;
+        }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             treeDensity += k4 + 4;
         }
@@ -320,6 +323,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_PLAINS) {
             byte0 = 3;
         }
+        if (biome == Biomes.OVERWORLD_CAATINGA) {
+            byte0 = 5;
+        }
         if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY || biome == Biomes.OVERWORLD_OUTBACK) {
             byte0 = 2;
         }
@@ -355,6 +361,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_PLAINS) {
             byte1 = 10;
         }
+        if (biome == Biomes.OVERWORLD_CAATINGA) {
+            byte1 = 3;
+        }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             byte1 = 4;
         }
@@ -446,6 +455,10 @@ public class ChunkDecoratorOverworld
         {
             k16 += 10;
         }
+        if(biome == Biomes.OVERWORLD_CAATINGA)
+        {
+            k16 += 3;
+        }
         for(int k18 = 0; k18 < k16; k18++)
         {
             int k21 = x + rand.nextInt(16) + 8;
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index a70327338..453ba9673 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -147,7 +147,7 @@ public class SurfaceGeneratorOverworld
                             // generate coastlines
                             topBlock = biome.topBlock;
                             fillerBlock = biome.fillerBlock;
-                            if(biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY)
+                            if(biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY)
                             {
                                 topBlock = (short) Block.mud.id;
                                 fillerBlock = (short) Block.mud.id;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
new file mode 100644
index 000000000..a50560754
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
@@ -0,0 +1,194 @@
+package net.minecraft.core.world.generate.feature.tree;
+
+import java.util.Random;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+public class WorldFeatureTreeCaatinga extends WorldFeature
+{
+    protected int leavesID;
+    protected int logID;
+    protected int heightMod = 2;
+
+    public WorldFeatureTreeCaatinga(int leavesID, int logID)
+    {
+        this.leavesID = leavesID;
+        this.logID = logID;
+    }
+
+    void placeBranch(int[] startPos, int[] endPos, int blockId, World world)
+    {
+        int[] dimensions = { 0, 0, 0 };
+        int dim0 = 0;
+
+        // Find widest dimension and assign it to dim0
+        for(int i = 0; i < 3; i++)
+        {
+            dimensions[i] = endPos[i] - startPos[i];
+            if(Math.abs(dimensions[i]) > Math.abs(dimensions[dim0]))
+            {
+                dim0 = i;
+            }
+        }
+
+        if(dimensions[dim0] == 0)
+        {
+            return;
+        }
+
+        // Look up other two dimensions
+        byte dim1 = dimensionLookup[dim0];
+        byte dim2 = dimensionLookup[dim0 + 3];
+
+        byte delta;
+        if(dimensions[dim0] > 0)
+        {
+            delta = 1;
+        }
+        else
+        {
+            delta = -1;
+        }
+
+        // Determine delta scale for other two dimensions
+        double dim1DeltaScale = (double)dimensions[dim1] / (double)dimensions[dim0];
+        double dim2DeltaScale = (double)dimensions[dim2] / (double)dimensions[dim0];
+
+        // Draw line from startPos to endPos
+        for(int i = 0; i != dimensions[dim0] + delta; i += delta)
+        {
+            int[] pos = { 0, 0, 0 };
+            pos[dim0] = MathHelper.floor_double((double)startPos[dim0] + (double)i + 0.5D);
+            pos[dim1] = MathHelper.floor_double((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
+            pos[dim2] = MathHelper.floor_double((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
+            world.setBlockWithNotify(pos[0], pos[1], pos[2], blockId);
+        }
+    }
+
+    @Override
+    public boolean generate(World world, Random random, int x, int y, int z)
+    {
+        int l = random.nextInt(3) + heightMod;
+        int noCanopies = 2;
+        boolean flag = true;
+        if(y < 1 || y + l + 1 > world.getHeightBlocks())
+        {
+            return false;
+        }
+        for(int i1 = y; i1 <= y + 1 + l; i1++)
+        {
+            byte byte0 = 1;
+            if(i1 == y)
+            {
+                byte0 = 0;
+            }
+            if(i1 >= (y + 1 + l) - 2)
+            {
+                byte0 = 2;
+            }
+            for(int i2 = x - byte0; i2 <= x + byte0 && flag; i2++)
+            {
+                for(int l2 = z - byte0; l2 <= z + byte0 && flag; l2++)
+                {
+                    if(i1 >= 0 && i1 < world.getHeightBlocks())
+                    {
+                        int j3 = world.getBlockId(i2, i1, l2);
+                        if(j3 != 0 && j3 != leavesID)
+                        {
+                            flag = false;
+                        }
+                    } else
+                    {
+                        flag = false;
+                    }
+                }
+
+            }
+
+        }
+
+        if(!flag)
+        {
+            return false;
+        }
+        int idBelow = world.getBlockId(x, y - 1, z);
+        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
+        {
+            return false;
+        }
+        WorldFeatureTree.onTreeGrown(world, x, y, z);
+        for(int i = 0; i < noCanopies; i++) {
+            int modX = random.nextInt(6) - 3;
+            int modZ = random.nextInt(6) - 3;
+            int modY = random.nextInt(3) + 1;
+            int x1 = x + modX;
+            int z1 = z + modZ;
+
+            for(int k1 = (y - 2) + l; k1 <= y + l; k1++)
+            {
+                int j2 = k1 - (y + l);
+                int i3 = 1 - j2 / 2;
+
+                for (int k3 = x - i3; k3 <= x + i3; k3++) {
+                    int l3 = k3 - x;
+                    for (int i4 = z - i3; i4 <= z + i3; i4++) {
+                        int j4 = i4 - z;
+                        if ((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(k3, k1, i4)]) {
+                            placeLeaves(world, k3+ modX, k1 + modY, i4+ modZ, random);
+                        }
+                    }
+
+                }
+            }
+            placeBranch(new int[]{x1, (y + modY + l) - 2, z1}, new int[]{x, (y - 2) + l, z}, logID, world);
+        }
+
+        for(int l1 = 0; l1 < l; l1++)
+        {
+            int id = world.getBlockId(x, y + l1, z);
+            if(id == 0 || isLeaf(id))
+            {
+                world.setBlockWithNotify(x, y + l1, z, logID);
+            }
+        }
+
+        return true;
+    }
+
+    public void placeLeaves(World world, int x, int y, int z, Random rand) {
+        world.setBlockWithNotify(x, y, z, leavesID);
+    }
+
+    public boolean isLeaf(int id) {
+        return id == leavesID;
+    }
+
+    /**
+     * Replace grass blocks below the tree with dirt
+     */
+    public static void onTreeGrown(World world, int x, int y, int z) {
+        Block dirt = WorldFeatureTree.getDirtForGrass(world.getBlockId(x, y - 1, z));
+        if(dirt != null) {
+            world.setBlockWithNotify(x, y - 1, z, dirt.id);
+        }
+    }
+
+    public static Block getDirtForGrass(int id) {
+        // TODO make this not hardcoded
+        if(id == Block.grass.id || id == Block.grassRetro.id) {
+            return Block.dirt;
+        }
+        if(id == Block.grassScorched.id) {
+            return Block.dirtScorched;
+        }
+        return null;
+    }
+
+    static final byte dimensionLookup[] = {
+            2, 0, 0, 1, 2, 1
+    };
+}
